#!/bin/bash

if [ "$1" = "cleanup" ]
then
  docker-compose down
  mvn clean
  exit
fi

trap 'kill $(jobs -p)' EXIT

mvn package

docker build -t trion/take-order-service:0 take-order

docker-compose up -d zookeeper kafka schema-registry

while ! [[ $(zookeeper-shell zookeeper:2181 ls /brokers/ids 2> /dev/null) =~ 1001 ]]; do echo "Waiting for kafka..."; sleep 1; done

kafka-topics --zookeeper zookeeper:2181 --if-not-exists --create --replication-factor 1 --partitions 5 --topic orders

docker-compose up -d take-order

kafka-avro-console-consumer --bootstrap-server kafka:9092 --topic orders &
sleep 10 # TODO: Warum ist /health nicht erreichbar?!?
http -v post 0:8091/orders Accept:*/* id=1 customerId=2 productId=234 quantity=5
http -v post 0:8091/orders Accept:*/* id=1 customerId=2 productId=234 quantity=
http -v post 0:8091/orders Accept:*/* id=1 customerId=2 productId=234 quantity=-5
http -v post 0:8091/orders Accept:*/* id=1 customerId=2 productId=-234 quantiyt=5
http -v post 0:8091/orders Accept:*/* customerId=2 productId=234 quantity=5
